<?php
/*
 * work with twig 20181005
 */
 
class doJCITwig {
	private $isTwig2 = false;
	private $isTwig3 = false;
	private $isTwig332 = false;
	private $parser = "twig";
    private $twig_environment_settings = NULL;
	private $twig_loader = NULL;
	private $twig_environment = NULL;
	private $datastructure = "";
	private $ts = NULL;
	private $result = "";
	private $jsonObj = array();
	private $debugmsg = "";
	private $maskspecialcharsinjsonFlag = TRUE;
	private $debug = FALSE;

	
	public function __construct($parser, $maskspecialcharsinjsonFlag){ # construct - setTwig - tryTwig - getTwigResult - getTwigDebug
		$this->parser = $parser;
		$this->maskspecialcharsinjsonFlag = $maskspecialcharsinjsonFlag;
		$this->jci_setup_twig_environment();
		$this->addTwigExtensions();
    }

	public function executeTwig($jsonObj, $datastructure, $parser, $maskspecialcharsinjsonFlag){
		$this->setTwig($jsonObj, $datastructure, $parser, $maskspecialcharsinjsonFlag);
		$this->tryTwig();
		return $this->getTwigResult();
	}

	public function getTwigResult(){
		return $this->result;
	}
	
	public function getTwigDebug(){
		return $this->debugmsg;
	}

	public function setTwig($jsonObj, $datastructure, $parser, $maskspecialcharsinjsonFlag){
		$this->debugmsg = ""; # clear 
		$this->parser = $parser;
		$this->jsonObj = $jsonObj;
		$this->datastructure = $datastructure;
		$this->maskspecialcharsinjsonFlag = $maskspecialcharsinjsonFlag;
		$this->setTwigTemplate();
	}

	public function tryTwigHandleCatchedError($e){
		// $template contains one or more syntax errors
		$this->jci_collectDebugMessage("twig: template-error: ".$e->getRawMessage());
		$errormsg = stripslashes(get_option('jci_pro_errormessage'));
		if (empty($errormsg)) {
			$this->result = "Twig-Error: ".$e->getRawMessage();
			return FALSE;
		}
		$this->result = $errormsg." (twig-error)";
		return FALSE;
	}

	public function tryTwig(){
		if ($this->isTwig2 || $this->isTwig3 || $this->isTwig332) {
			try {
				$this->twig_environment->parse($this->twig_environment->tokenize($this->ts));
			} catch (\Twig\Error\SyntaxError $e) {
				return $this->tryTwigHandleCatchedError($e);
			}
		} else {
			try {
				$this->twig_environment->parse($this->twig_environment->tokenize($this->ts));
			} catch (Twig_Error_Syntax $e) {
				return $this->tryTwigHandleCatchedError($e);
			}
		}
		$template = $this->twig_environment->createTemplate($this->datastructure);
		$this->jci_collectDebugMessage("twig-template: ".$this->datastructure);
		$this->jci_collectDebugMessage("twig-JSON: ".print_r($this->jsonObj, TRUE));
		$resultTmp = $template->render($this->jsonObj);
		$this->result = $this->unmaskSpecialCharsInJSON($resultTmp);
		return TRUE;
	}
		
	public function maskSpecialCharsInJSON($intxt) {
        if (!$this->maskspecialcharsinjsonFlag) {
          return $intxt;
        }
        $intxt = preg_replace('/\$/', "_symbol_dollar_", $intxt);
        #$intxt = preg_replace('/</', "_symbol_smallerthan_", $intxt);
        #$intxt = preg_replace('/>/', "_symbol_greaterthan_", $intxt);
        #   $intxt = preg_replace('/\\\\\"/', "_symbol_backslash_masking_quotationmark_", $intxt);
        $intxt = preg_replace('/\\\\\//', "_symbol_backslash_masking_slash_", $intxt);
        #$intxt = preg_replace('/\//', "_symbol_slash_", $intxt);
        $intxt = preg_replace("/\@/", "_symbol_at_", $intxt);
        $intxt = preg_replace("/\!/", "_symbol_exclamationmark_", $intxt);
        return $intxt;
	}

	public function unMaskSpecialCharsInJSON($intxt) {
        if (!$this->maskspecialcharsinjsonFlag) {
          return $intxt;
        }
        $intxt = preg_replace("/_symbol_slash_/i", '/', $intxt);
        $intxt = preg_replace('/_symbol_backslash_masking_slash_/', '/', $intxt);
        $intxt = preg_replace('/_symbol_backslash_masking_quotationmark_/', '"', $intxt);
        $intxt = preg_replace("/_symbol_sqrbracket_open_/i", '[', $intxt);
        $intxt = preg_replace("/_symbol_sqrbracket_close_/i", ']', $intxt);
        $intxt = preg_replace("/_symbol_curlbracket_open_/i", '{', $intxt);
        $intxt = preg_replace("/_symbol_curlbracket_close_/i", '}', $intxt);
        $intxt = preg_replace("/_symbol_at_/i", "@", $intxt);
        $intxt = preg_replace("/_symbol_dot_/i", ".", $intxt);
        $intxt = preg_replace("/_symbol_exclamationmark_/i", "!", $intxt);
        $intxt = preg_replace('/_symbol_smallerthan_/', "<", $intxt);
        $intxt = preg_replace('/_symbol_greaterthan_/', ">", $intxt);
        $intxt = preg_replace("/_symbol_dollar_/i", '$', $intxt);
        return $intxt;
	}

	private function jci_setup_twig_environment() {
		# load and register Twig
		$tmppath = "";
		
	
		if (class_exists( 'Twig_Autoloader' )) {
		
			$foundTwigVersion = $this->jci_getSelectedTwigVersion(); # Twig_Environment::VERSION;
			if (preg_match("/^1/", $foundTwigVersion)) {
				$this->isTwig2 = FALSE;
				$this->isTwig3 = FALSE; 
				$this->isTwig332 = FALSE; 
			}
			if (preg_match("/^2/", $foundTwigVersion)) {
				$this->isTwig2 = TRUE;
				$this->isTwig3 = FALSE; 
				$this->isTwig332 = FALSE; 
			}
			if (preg_match("/^3/", $foundTwigVersion)) {
				$this->isTwig3 = TRUE; 
				$this->isTwig2 = FALSE; 
				$this->isTwig332 = FALSE; 
			}
			if (preg_match("/^3.3.2/", $foundTwigVersion)) {
				$this->isTwig3 = FALSE; 
				$this->isTwig2 = FALSE; 
				$this->isTwig332 = TRUE; 
			}
			$this->jci_collectDebugMessage("plugin is using Twig from another plugin: twig-version is ".$foundTwigVersion);
		} else {
			$this->jci_collectDebugMessage("load Twig ".$this->parser." from JCI-plugin");
			if ($this->parser=="twig243") {
				$inc = WP_PLUGIN_DIR . '/jsoncontentimporterpro3/twiglib/twig243/vendor/autoload.php';
				require_once $inc;
				$this->isTwig2 = TRUE;
			} else if ($this->parser=="twig3") {
				$inc = WP_PLUGIN_DIR . '/jsoncontentimporterpro3/twiglib/twig3/vendor/autoload.php';
				require_once $inc;
				$this->isTwig3 = TRUE;
			} else if ($this->parser=="twig332") {
				$inc = WP_PLUGIN_DIR . '/jsoncontentimporterpro3/twiglib/twig332/vendor/autoload.php';
				require_once $inc;
				$this->isTwig332 = TRUE;
			} else {
				$inc = WP_PLUGIN_DIR . '/jsoncontentimporterpro3/twiglib/twig1/Twig/Autoloader.php';
				if (!file_exists($inc) || !is_readable($inc)) {
					$this->jci_collectDebugMessage("Twig not found in ".$inc);
				} else {
					require_once $inc;
				}
				Twig_Autoloader::register();
			}
		}
		
		if ($this->isTwig3 || $this->isTwig332) { 				# as we load the template via shortcode-param this is not needed - but I don't know how to avoid it...
			$this->twig_loader = new \Twig\Loader\FilesystemLoader(WP_PLUGIN_DIR."/jsoncontentimporterpro3/"); 
		} else {
			$this->twig_loader = new Twig_Loader_Filesystem(WP_PLUGIN_DIR."/jsoncontentimporterpro3/");
		}
		
		# set twig options
		$this->twig_environment_settings = array(
			'charset' => get_bloginfo('charset'),  # default is utf-8
			'autoescape' => false,
			'strict_variables' => false,  # otherwise errors thrown
			'auto_reload' => true,
			#'cache' => WP_CONTENT_DIR.'/cache/jsoncontentimporterpro/twigcache',
		);

		$cachepathdynamic = get_option('jci_pro_cache_path');
		if (empty($cachepathdynamic)) {
			$cache4Twig = WP_CONTENT_DIR.'/cache/jsoncontentimporterpro/twigcache';
		} else {
			$cache4Twig = $cachepathdynamic;
			if (!preg_match("/\/$/", $cache4Twig)) {
				$cache4Twig .= "/";
			}
			$cache4Twig .= 'twigcache';
		}
		$twigcacheactive = TRUE;
		if (1!=get_option('jci_pro_enable_twigcache')) {
			$twigcacheactive = FALSE;
		}
		$twigCacheDirThere = FALSE;
		if (is_dir($cache4Twig)) {
			# all there
			$twigCacheDirThere = TRUE;
		} else if (!empty($cache4Twig)) {
			if ($twigcacheactive) {
				$mkdirError2 = @mkdir($cache4Twig, 0777, TRUE);
				if (is_dir($cache4Twig)) {
					# all there
					$twigCacheDirThere = TRUE;
				}
			}
		}
		if ($twigCacheDirThere && $twigcacheactive) {
			# all there
			$this->jci_collectDebugMessage("Twig cache active: ".$cache4Twig);
			$this->twig_environment_settings['cache'] = $cache4Twig;
		} else if ($twigcacheactive) {
			$this->jci_collectDebugMessage("Twig cache dir not there: ".$cache4Twig);
		}

		if (defined('WP_DEBUG') && true === WP_DEBUG) {
			$this->twig_environment_settings['debug'] = true;
		}

		# invoke Twig
		
		if ($this->parser=="twig3" || $this->parser=="twig332") {
			$this->twig_environment = new \Twig\Environment($this->twig_loader, $this->twig_environment_settings);
			if (defined('WP_DEBUG') && true === WP_DEBUG) {
				$this->twig_environment->addExtension(new \Twig\Extension\DebugExtension());
			}
		} else {
			$this->twig_environment = new Twig_Environment($this->twig_loader, $this->twig_environment_settings);
			if (defined('WP_DEBUG') && true === WP_DEBUG) {
				$this->twig_environment->addExtension(new Twig_Extension_Debug());
			}
		}

		$this->jci_collectDebugMessage("success - Twig loaded, version: ".$this->jci_getSelectedTwigVersion()); 
	}

	private  function jci_collectDebugMessage($msg){
		$this->debugmsg .= htmlentities($msg)."<br>";
	}

	public function jci_getSelectedTwigVersion(){
		if ($this->isTwig2 || $this->isTwig3 ||$this->isTwig332 ) {
			return \Twig\Environment::VERSION;
		} else {
			return Twig_Environment::VERSION;
		}
	}

	private function setTwigTemplate(){
       if ($this->parser=="twig") {
          $this->ts = $this->datastructure;
        } else if ($this->isTwig2) {
          $this->ts = new Twig_Source($this->datastructure, "");
        } else if ($this->isTwig3 || $this->isTwig332) {
			$this->ts = new \Twig\Source($this->datastructure, "");
		}
    }
	
	
	private function twig_ext_sortbyjsonfield($data, $sortdata) {
			$sortdataArr = explode("##", $sortdata);
			$i = 1;
			foreach ($sortdataArr as $val) {
				$sortdetailArr = explode(",", $val);
				$sortfield[$i] = trim($sortdetailArr[0]);
				$sortorder[$i] = "";
				if (isset($sortdetailArr[1])) {
					if ("desc"==trim($sortdetailArr[1])) {
						$sortorder[$i] = "desc";
					}
				}
				$sortflag[$i] = "";
				if (isset($sortdetailArr[2])) {
					if ("num"==trim($sortdetailArr[2])) {
						$sortflag[$i] = "num";
					}
					if (preg_match("/^date/", trim($sortdetailArr[2]))) {
						$sortflag[$i] = $sortdetailArr[2];
					}
				}
				$i++;
			}
			$data = $this->sortJsonArray($data, $sortfield, $sortorder, $sortflag);
			return $data;
	}
	
	private function twig_ext_dateformat($data, $dateformatstr, $datetimezone, $datelocale) {
		    $curentTimezone = date_default_timezone_get();
 		    date_default_timezone_set($datetimezone);
		    $validDateLocale = FALSE;
		    if (preg_match("/([a-z_]*)/i", $datelocale)) {
				$validDateLocale = TRUE;
		    }
		    if ($validDateLocale) {
			    $getlocale = setlocale (LC_TIME,"0");
			    setlocale(LC_TIME, $datelocale);
		    }
			if (!( is_numeric($data) && (int)$data == $data )) {
				$data = strtotime($data);
			}
		    $formattedDate = strftime($dateformatstr, $data);
		    if ($validDateLocale) {
			    setlocale(LC_TIME, $getlocale);
		    }
		    date_default_timezone_set($curentTimezone);
		    return $formattedDate;
	}
	
	private function twig_ext_converthex2ascii($data) {
          #$data = "0xefef39a10000000000000000000000000000000000000000000000000000000000000005";
          $dataTmp = substr($data, 2, strlen($data));
          $dataTmp = @hex2bin ($dataTmp);
          if ($dataTmp) {
            $data = $dataTmp;
          }
	    return $data;
	}
	
	private function twig_ext_convert2html($data) {
		 $data = $this->unMaskSpecialCharsInJSON($data);
         $dataTmp = htmlentities($data, TRUE);
         if (empty($dataTmp)) {
           return $this->maskSpecialCharsInJSON($data);
         }
         return $this->maskSpecialCharsInJSON($dataTmp);
	}

	private function twig_ext_dump($data) {
		 $dataDump = print_R($data, TRUE);
		 return $dataDump;
	}

	private function twig_ext_md5($data) {
		 $datamd5 = md5($data);
		 return $datamd5;
	}

	private function twig_ext_preg_replace($data, $pattern, $replacement) {
		$dataModified = preg_replace($pattern, $replacement, $data);
		 return $dataModified;
	}

	private function twig_ext_sortbyarray($data, $sorttype, $sortflag=SORT_REGULAR) {
			if (!($sortflag>0)) {
				$sortflag = SORT_REGULAR;
			}
			if ("arsort"==$sorttype) {
				arsort($data, $sortflag);
			}
			if ("asort"==$sorttype) {
				asort($data, $sortflag);
			}
			if ("rsort"==$sorttype) {
				rsort($data, $sortflag);
			}
			if ("ksort"==$sorttype) {
				ksort($data, $sortflag);
			}
			if ("krsort"==$sorttype) {
				krsort($data, $sortflag);
			}
		return $data;
	}

	private function twig_ext_html_entity_decode($data, $flags="", $encoding="") {
		  if (empty($encoding)) {
			$encoding = ini_get("default_charset");
		}
		$flagbitmask = 0;
		   
		if (empty($flags)) {
			$flags = ENT_COMPAT | ENT_HTML401;
		} else {
			$flagsArr = explode("|", $flags);
			foreach($flagsArr as $fl) {
				$cval = constant(trim($fl));
				$flagbitmask = $flagbitmask | $cval;
			}
		}

		$dataModified = html_entity_decode($dataModified, $flagbitmask, $encoding);
		 return $dataModified;
	}

	private function twig_ext_removenonprintable($data, $replacement) {
		$dataModified = preg_replace( '/[^[:print:]]/', $replacement, $data);
		 return $dataModified;
	}


	private function twig_ext_htmlentities($data, $flags, $encoding, $double_encode) {
		if (empty($flags)) {
			$flags = ENT_COMPAT | ENT_HTML401;
		}
		if (empty($encoding)) {
			$encoding = ini_get("default_charset");
		}
		if (empty($double_encode)) {
			$double_encode = TRUE;
		}
		$dataModified = htmlentities($data, $flags, $encoding, $double_encode);
		 return $dataModified;
	}
	
	private function twig_ext_htmlspecialchars_decode($data) {
		 $data = $this->unMaskSpecialCharsInJSON($data);
		 $dataTmp = htmlspecialchars_decode($data);
         if (empty($dataTmp)) {
           return $this->maskSpecialCharsInJSON($data);
         }
         return $this->maskSpecialCharsInJSON($dataTmp);
	}

	private function twig_ext_base64encode($data) {
         $data = $this->unMaskSpecialCharsInJSON($data);
         $dataTmp = base64_encode($data);
         if (empty($dataTmp)) {
           return $this->maskSpecialCharsInJSON($data);
         }
         return $this->maskSpecialCharsInJSON($dataTmp);
	}

	private function twig_ext_removespecialcharsinurl($data) {
         $data = $this->unMaskSpecialCharsInJSON($data);
         $data = strtolower($data);
         $data = preg_replace("/ /i", "-", $data);
         $data = str_replace(array('ä','ö','ü','ß','Ä','Ö','Ü', '&auml;', '&ouml;', '&uuml;', '&szlig;', '&Auml;', '&Ouml;', '&Uuml;'),array('ae','oe','ue','ss','Ae','Oe','Ue', 'ae', 'oe', 'ue', 'ss', 'Ae', 'Oe', 'Ue'),utf8_decode($data));
         $data = preg_replace("/[^a-z0-9\-]/i", "", $data);
         $data = $this->maskSpecialCharsInJSON($data);
         return $data;
	}

	private function twig_ext_stringshorter($data, $length, $suffix) {
			$data = $this->unMaskSpecialCharsInJSON($data);
			if (strlen($data)<=$length) {
				return $this->maskSpecialCharsInJSON($data);
			}
			$data = mb_substr($data, 0, $length).$suffix;
			return $this->maskSpecialCharsInJSON($data);
	}

	private function twig_ext_doshortcode($data) {
		return do_shortcode($data);
	}

	private function twig_ext_jsondecode($data, $assoc=FALSE, $depth=512, $options=0 ) {
		$jde = json_decode($data, $assoc, $depth, $options);
		if (is_null($jde)) {
			return '{"json_decode":"null"}';
		} 
		return $jde;
	}

	private function twig_ext_jsondecode4twig($data, $assoc=FALSE, $depth=512, $options=0 ) {
		return $this->twig_ext_jsondecode($data, TRUE, $depth, $options );
	}

	private function twig_ext_get_data_of_uploaded_file($filename) {
		if (isset($_FILES[$filename])) {
			return $_FILES[$filename];
		}
		return NULL;
	}

	private function twig_ext_get_file($filename) {
		if (file_exists($filename)) {
			$tmpdata = @file_get_contents($filename);
			return $tmpdata;
		}
		return NULL;
	}
	
	private function twig_ext_db_delete($db_table_name, $db_where="", $is_wp_db=1) {  
		# DELETE FROM $db_table_name WHERE $db_where;
		require_once "wp-load.php";
		global $wpdb;
		$dbreturn = Array();

		$sql = "DELETE FROM ";
		if (1==$is_wp_db) {
			$sql .= $wpdb->prefix;
		}
		$sql .= "`".$db_table_name."` ";
		if (!empty($db_where)) {
			$sql .= " WHERE ".$db_where;
		}
		$dbreturn = $this->jci_execute_db_request($wpdb, $sql);
		return $dbreturn;
	}
	
	private function jci_execute_db_request($wpdb, $sql, $request="") {  
		$dbreturn = Array();
		$wpdb->hide_errors();
		if (empty($request)) {
			$myrows = $wpdb->query($sql);
		} else if ("get_results" == $request) {
			$myrows = $wpdb->get_results($sql);
		} else {
			return NULL;
		}
		if($wpdb->last_error == '') {
			$dbreturn["success"] = TRUE;
			$dbreturn["result"] = $myrows;
		} else {
			$dbreturn["success"] = FALSE;
			$dbreturn["result"] = $wpdb->last_error;
		}
		return $dbreturn;
	}
	
	
	
	private function jci_join_params( $params ) {
		$query_params = array();
		foreach ( $params as $param_key => $param_value ) {
			$string = $param_key . '=' . $param_value;
			$query_params[] = str_replace( array( '+', '%7E' ), array( ' ', '~' ), rawurlencode( $string ) );
		}
		return implode( '%26', $query_params );
	}	
	
	
	private function twig_extra_function_jci_forward($url) {
		header('Location: '.$url);
		exit;
	}

	private function twig_extra_function_jci_getcookie($name) {
		if (empty($name)) {
			return $_COOKIE;
		}
		return $_COOKIE[$name];
	}

	private function twig_extra_function_jci_setcookie($name, $value="", $expires=0, $path="", $domain="", $secure=false, $httponly=false) {
		if (empty($name)) {
			return NULL;
		}
		$errorlevSetCookie = setcookie($name, $value, $expires, $path, $domain, $secure, $httponly);
		/*if ($errorlevSetCookie) {
			echo "OK: setcookie $name<br>";
		} else {
			echo "FAIL: setcookie $name<br>";
		}*/
	}

	private function twig_extra_function_woocommmerce_calc_authorization($consumer_key, $consumer_secret, $request_uri, $http_method) {
		if (empty($consumer_key) || empty($consumer_secret) || empty($request_uri) || empty($http_method)) {
			return "";
		}
		$nonce = uniqid();
		$timestamp = time();
		$oauth_signature_method = 'HMAC-SHA1';
		$hash_algorithm = strtolower( str_replace( 'HMAC-', '', $oauth_signature_method ) ); // sha1
		$secret = $consumer_secret . '&';

		$base_request_uri = rawurlencode( $request_uri );
		$params = array( 
			'oauth_consumer_key' => $consumer_key, 
			'oauth_nonce' => $nonce, 
			'oauth_signature_method' => $oauth_signature_method, 
			'oauth_timestamp' => $timestamp 
		);
		$query_string = $this->jci_join_params( $params );

		$string_to_sign = $http_method . '&' . $base_request_uri . '&' . $query_string;
		$oauth_signature = base64_encode( hash_hmac( $hash_algorithm, $string_to_sign, $secret, true ) );
		
		$authstr = "Authorization: OAuth oauth_consumer_key=\"".$consumer_key."\",oauth_signature_method=\"".$oauth_signature_method."\",oauth_timestamp=\"".$timestamp."\",oauth_nonce=\"".$nonce."\",oauth_signature=\"".$oauth_signature."\"";
		return $authstr;
	}


	private function twig_extra_function_user_create($username, $password, $email="", $role="") {
		$dbreturn = Array();
		if (empty($username) || empty($password)) {
			$dbreturn["success"] = FALSE;
			$dbreturn["result"] = "username or passwort empty: no new user created";
			return $dbreturn;
		}

		$roleexisting = FALSE;
		if (!empty($role)) {
			$rolelist = wp_roles();
			foreach ($rolelist->roles as $k=>$v) {
				if ($k==$role) {
					$roleexisting = TRUE;
					break;
				}
			}
			if (!$roleexisting) {
				$dbreturn["success"] = FALSE;
				$dbreturn["result"] = "role for new user not existing - no new user created";
				return $dbreturn;
			}
		}
		
		$newuser = wp_create_user($username, $password, $email);
		if( is_wp_error( $newuser ) ) {
			$dbreturn["success"] = FALSE;
			$dbreturn["result"] = $newuser->get_error_message();
			return $dbreturn;
		}	
		if ($roleexisting) {
			$usridrole = new WP_User($newuser);
			$usridrole->set_role($role);
		}
		$dbreturn["success"] = TRUE;
		$dbreturn["result"] = $newuser;
		return $dbreturn;
	}

	private function twig_ext_db_create($db_table_name, $json_for_db) {  
		# CREATE TABLE table_name (    column2 datatype,    column3 datatype,   ....); 
		require_once "wp-load.php";
		global $wpdb;
		$dbreturn = Array();
		$jsonInsertArr = json_decode($json_for_db, TRUE);
		if (is_null($jsonInsertArr )) {
			$dbreturn["error"] = FALSE;
			$dbreturn["result"] = "invalid json";
			$dbreturn["json"] = $json_for_db;
			return $dbreturn;
		}
		$sql = "CREATE TABLE ";
		$sql .= "`".$db_table_name."` ( ";
		$updatestr = "";
		foreach($jsonInsertArr as $k=>$v) {
			$updatestr .= $k." ";
			$updatestr .= $v.",";
		}
		$createstr = rtrim($updatestr, ",");
		$sql .= $createstr." ) ";
		$dbreturn = $this->jci_execute_db_request($wpdb, $sql);
		return $dbreturn;
	}

	private function twig_ext_db_update($db_table_name, $json_for_db, $db_where="", $is_wp_db=1) {  
		# UPDATE table_name SET column1 = value1, column2 = value2, ... WHERE condition; 
		require_once "wp-load.php";
		global $wpdb;
		$dbreturn = Array();
		$jsonInsertArr = json_decode($json_for_db, TRUE);
		if (is_null($jsonInsertArr )) {
			$dbreturn["error"] = FALSE;
			$dbreturn["result"] = "invalid json";
			$dbreturn["json"] = $json_for_db;
			return $dbreturn;
		}
		$sql = "UPDATE ";
		if (1==$is_wp_db) {
			$sql .= $wpdb->prefix;
		}
		$sql .= "`".$db_table_name."` SET ";
		$updatestr = "";
		foreach($jsonInsertArr as $k=>$v) {
			$updatestr .= "`".$k."`=";
			$updatestr .= "'".$v."',";
		}
		$updatestr = rtrim($updatestr, ",");
		$sql .= $updatestr;
		if (!empty($db_where)) {
			$sql .= " WHERE ".$db_where;
		}
		$dbreturn = $this->jci_execute_db_request($wpdb, $sql);
		return $dbreturn;
	}


	private function twig_ext_db_insert($db_table_name, $json_for_db, $is_wp_db=1) {  
		# INSERT INTO '$db_table_name' ('key1', 'key2',... ) VALUES ('val1', 'val2',...)
		require_once "wp-load.php";
		global $wpdb;
		$dbreturn = Array();
		$jsonInsertArr = json_decode($json_for_db, TRUE);
		if (is_null($jsonInsertArr )) {
			$dbreturn["error"] = FALSE;
			$dbreturn["result"] = "invalid json";
			$dbreturn["json"] = $json_for_db;
			return $dbreturn;
		}
		$sql = "INSERT INTO ";
		if (1==$is_wp_db) {
			$sql .= $wpdb->prefix;
		}
		$sql .= "`".$db_table_name."` ";
		$keystr = "";
		$valstr = "";
		foreach($jsonInsertArr as $k=>$v) {
			$keystr .= "`".$k."`,";
			$valstr .= "'".$v."',";
		}
		$keystr = rtrim($keystr, ",");
		$valstr = rtrim($valstr, ",");
		$sql .= "(".$keystr.") VALUES "."(".$valstr.")"; 
		$dbreturn = $this->jci_execute_db_request($wpdb, $sql);
		return $dbreturn;
	}
	
	private function twig_ext_db_select($db_fields, $db_table_name, $db_where="", $is_wp_db=1) {  
		# SELECT $db_fields FROM $db_table_name WHERE $db_where
		require_once "wp-load.php";
		global $wpdb;
		$sql = "SELECT ".$db_fields." FROM ";
		if (1==$is_wp_db) {
			$sql .= $wpdb->prefix;
		}
		$sql .= $db_table_name;
		if (!empty($db_where)) {
			$sql .= " WHERE ".$db_where;
		}
		$dbreturn = $this->jci_execute_db_request($wpdb, $sql, "get_results");
		return $dbreturn;
	}

	private function twig_ext_base64encode_savefile($filename) {
			#return NULL;
			$filenameb64 = $filename.'-b64';
			$chunkSize = 1024;
			$src = fopen($filename, 'rb');
			$dst = fopen($filenameb64, 'wb');
			while (!feof($src)) {
				fwrite($dst, base64_decode(fread($src, $chunkSize)));
			}
			fclose($dst);
			fclose($src);	
			return $filenameb64;
	}

	private function debug_out($intromsg, $msg) {
		if ($this->debug) {
			echo $intromsg.": ".htmlentities($msg)."<br>"; 
		}
	}

	private function twig_ext_delete_custom_post(int $postid, bool $force_delete = FALSE, $debug=FALSE) {
		$this->debug_out("delete CP - postid", $postid); 
		$delcpt = wp_delete_post($postid, $force_delete);
		return $delcpt;
	}

	private function twig_ext_create_new_custom_post($cptslug, $titel="set title in twig, please", $name="set name in twig, please", $content="set content in twig, please", $publishdate="", $postStatusUsed="publish", $authorid="", $debug=FALSE) {
		$this->debug = $debug;
		$this->debug_out("create CP - cptslug", $cptslug); 
		$this->debug_out("create CP - publishdate in", $publishdate); 
		
		$publishdate = $this->executeTwig($this->jsonObj, $publishdate, "twig3", FALSE); # required format is Y-m-d H:i:s 
		$timestampofdate = strtotime($publishdate);
		$publishdate = date('Y-m-d H:i:s', $timestampofdate);
		if (empty($publishdate)) {
			$publishdate = date('Y-m-d H:i:s', strtotime('now'));
		}
		$this->debug_out("create CP - publishdate used", $publishdate); 
		$titel = $this->executeTwig($this->jsonObj, $titel, "twig3", FALSE);
		$this->debug_out("create CP - titel", $titel); 

		$name = $this->executeTwig($this->jsonObj, $name, "twig3", FALSE);
		$this->debug_out("create CP - name", $name); 

		$content = $this->executeTwig($this->jsonObj, $content, "twig3", FALSE);
		$this->debug_out("create CP - content", $content); 

		$this->debug_out("create CP - postStatusUsed", $postStatusUsed); 
		if (empty($authorid)) {
			$authorid = get_current_user_id();
		}
		$this->debug_out("create CP - authorid", $authorid); 

		$newPostArr = array(
			'post_title'   => $titel,
			'post_name'    => $name,
			'post_content' => $content,
			'post_status'  => $postStatusUsed,
			'post_type'    => $cptslug,
			'post_date'    => $publishdate, 
			'post_author'  => $authorid,
			# 'post_category'=> $newPostCategory,
			# 'post_parent'  =>
		);
		$idOfNewPost = wp_insert_post($newPostArr);
		$this->debug_out("create CP - idOfNewPost", $idOfNewPost); 
		$this->debug = FALSE;
		return $idOfNewPost;						
	}
	
	private function twig_ext_insert_taxonomy($pageid, $taxonomySlug, $taxonomyValue, $debug=FALSE) {
		$this->debug = $debug;
		$el = wp_set_object_terms( $pageid, $taxonomyValue, $taxonomySlug ); 
		$this->debug_out("add taxonomy to page $pageid", "$taxonomySlug / $taxonomyValue"); 
		$this->debug = FALSE;
		if( is_wp_error( $el ) ) {
			return $el->get_error_message();
		}		
		return json_encode($el);
	}
	
	private function twig_ext_clear_taxonomy($taxonomySlug, $debug=FALSE) {
		$this->debug = $debug;
		$getTerms = get_terms( $taxonomySlug, array( 'fields' => 'ids', 'hide_empty' => false ) ); # get all pages with this taxonomyslug
		$this->debug_out("clear taxonomy $taxonomySlug", json_encode($getTerms)); 
		$this->debug = FALSE;
		foreach ( $getTerms as $valueTax ) {
			wp_delete_term( $valueTax, $taxonomySlug );
		}
		return json_encode($getTerms);
	}
	
	
	private function twig_ext_get_cp_by_cpf_keyvalue($post_type="", $key="", $value="", $debug=FALSE) {
		if (empty($post_type)) {
			return "twig_ext_get_cp_by_cpf_keyvalue(SLUG_OF_CPT, CPF_KEY, CPF_VALUE, DEBUG_BOOLEAN_FLAG)<br>";
		}
		$this->debug = $debug;
		$this->debug_out("get CP by CPF key:value ", "$key: $value"); 
		$value = $this->executeTwig($this->jsonObj, $value, "twig3", FALSE);
		
		$getpostArray = array(
			'numberposts'	=> -1,
			'post_type'		=> $post_type,
		);

		if (!empty($key) && !empty($value)) {
			$keyValueArray = array(
				array(
					'key'	 	=> $key,
					'value'	  	=> $value,
				)
			);
			$getpostArray['meta_query'] = $keyValueArray;
		}
		
		$posts = get_posts($getpostArray);	
		$out = Array();
		$i = 0;
		if( $posts ) {
			foreach( $posts as $post ) {
				$out[$i] = $post->ID;
				$i++;
			}
		}
		$this->debug = FALSE;
		return $out;
	}
	
	private function twig_ext_get_page_properties($debug=FALSE) {
		$this->debug = $debug;
		$propArr = Array();
		$propArr["get_permalink"] = get_permalink();
		$propArr["home_url"] = home_url();
		$userid = get_current_user_id();
		$propArr["get_current_user_id"] = $userid;
		$usrdataArr = get_userdata($userid);
		$propArr["userdata"] = $usrdataArr;

		$postparam = get_post();
		$postparam->post_content = preg_replace("/jsoncontentimporterpro/", "", trim($postparam->post_content)); # shortcode in $postparam->post_content are executed when used in twig, result: infinite loop or plugin-termination -> remove "jsoncontentimporterpro" to invalidate shortcode
		$propArr["get_post"] = $postparam;
		
		$pageid = $postparam->ID;
		$cpflist = get_post_meta($pageid);
		if (is_array($cpflist)) {
			$propArr["cpf"] = $cpflist;
		}
		$this->debug_out("get page properties", print_r($propArr, TRUE)); 

		$this->debug = FALSE;
		return $propArr;
	}



	private function twig_ext_get_custom_field_value($pageid, $key="", $debug=FALSE) {
		$this->debug = $debug;
		$this->debug_out("get custom field value", "pageid: $pageid / key in: $key"); 
		$key = $this->executeTwig($this->jsonObj, $key, "twig3", FALSE);
		if (empty($key)) {
			$this->debug_out("get custom field value", "key is empty, no CPF"); 
			$this->debug = FALSE;
			return "";
		}
		$key = $this->executeTwig($this->jsonObj, $key, "twig3", FALSE);
		$this->debug_out("get custom field value", "pageid: $pageid / key used: $key"); 
		$cpfvalue = get_post_custom_values($key, $pageid);
		$this->debug_out("get custom field value", "found value: ".print_r($cpfvalue, TRUE)); 
		$this->debug = FALSE;
		return $cpfvalue;
	}

	private function twig_ext_create_insert_custom_field_keyvalue($pageid, $key="", $value="", $debug=FALSE) {
		$this->debug = $debug;
		$this->debug_out("set CPF $pageid in", "$key : $value"); 
		$key = $this->executeTwig($this->jsonObj, $key, "twig3", FALSE);
		$value = $this->executeTwig($this->jsonObj, $value, "twig3", FALSE);
		$cpfinsertstatus = NULL;
		if (!empty($key) && !empty($value)) {
			$cpfinsertstatus = update_post_meta($pageid, $key, $value);
			$this->debug_out("set CPF $pageid used", "$key : $value, Status: $cpfinsertstatus"); 
		} else {
			$this->debug_out("set CPF $pageid not SET (empty key or value)", "$key : $value"); 
		}
		$this->debug = FALSE;
		return $cpfinsertstatus;
	}

	private function twig_ext_urldecode($data) {
		return urldecode($data);
	}
	private function twig_ext_stripslashes($data) {
		return stripslashes($data);
	}
	
	private function twig_ext_mediastore($data) {
		if (is_null($data)) {
			return NULL;
		}
		#$filename = basename($data); # simple way: but what if name of file is the same in several JSON-datasets? --> use complete URL for name of to be stored image
		$filename = preg_replace("/\//", "-", $data);
		$filename = preg_replace("/\-\-/", "-", $filename);
		$filename = preg_replace("/\:/", "", $filename);
		$filename = preg_replace("/\?/", "QM", $filename);
		$filename = preg_replace("/\#/", "HT", $filename);
		$filename = preg_replace("/\=/", "EQ", $filename);
		$filename = urlencode($filename);
		
		$fileextensionTmp = explode("?", $data, 2); # if there are some get-params in the URL: extract the image-type
		if (count($fileextensionTmp)>1) {
			$fileextensionTmp1 = explode(".", $fileextensionTmp[0]);
			$felast = count($fileextensionTmp1)-1;
			$fileextension = @$fileextensionTmp1[$felast];
			if (""!=$fileextension) {
				$filename .= ".".$fileextension;
			}
		}

		#$retval = "###jci#1#".$filename."#2#";
		$retval["jci"]["filename"] = $filename;
			$retval["jci"]["status"] = "";

		$this->CheckLibraryOnMediafile($filename);

		# load and store mediafile
		$uploadfile = wp_upload_bits($filename, null, file_get_contents($data)); # return: file, urltype, error (bool)
		#var_Dump($uploadfile);
		if ($uploadfile['error']) {
			$retval["jci"]["status"] = "upload failed";
			#$retval .= "upload failed";
			return json_encode($retval);
		} else {
			$wp_filetype = wp_check_filetype($filename, null );
			$attachment = array(
				'post_mime_type' => $wp_filetype['type'],
				#	'post_parent' => $parent_post_id,
				'post_title' => $filename,
				'post_content' => '',
				'post_status' => 'inherit'
			);
			
			$attachment_id = wp_insert_attachment( $attachment, $uploadfile['file']);
			if (is_wp_error($attachment_id)) {
				$retval["jci"]["status"] = "is_wp_error";
				#$retval .= "0";
			} else {
				require_once(ABSPATH . "wp-admin" . '/includes/image.php');
				$attachment_data = wp_generate_attachment_metadata( $attachment_id, $uploadfile['file'] );
				wp_update_attachment_metadata( $attachment_id,  $attachment_data );
				$retval["jci"]["status"] = "ok";
				#$retval .= $attachment_id;
				$retval["jci"]["attachment_id"] = $attachment_id;
				#var_dump($attachment);
				$retval["jci"]["attachment_url"] = wp_get_attachment_url($attachment_id);
			}
		}
	
		
		return json_encode($retval);
	}
	
	
	private function CheckLibraryOnMediafile($filename){
		global $wpdb;
		# get filename and extension
		$query = "SELECT ID FROM $wpdb->posts WHERE post_type='attachment' AND post_title = '".$filename."'";
		$resArr = $wpdb->get_results($query);
		#echo "<br>filename: $filename<br>";
		#var_Dump($resArr);
		if (0==count($resArr)) {
			return TRUE;
		} else {
			foreach( $resArr as $key => $row) {
				#echo "DELETE: $key<br";
				$upldir = wp_get_upload_dir();
				$baseURLUploads = $upldir["baseurl"];
				$baseDIRUploads = $upldir["basedir"];

				$postid = $row->ID;
				$atturl = wp_get_attachment_url($postid);
				$r = explode($baseURLUploads, $atturl);
				$r1 = explode("/", $r[1]);
				$mainfilename = array_pop($r1);
				$pa = $baseDIRUploads.join("/", $r1)."/";
				
				$attmdArr = wp_get_attachment_metadata($postid);
				#echo "<br>";
				#var_Dump($attmdArr);
				#echo "<br>";
				foreach($attmdArr["sizes"] as $k => $v) {
					$oldfile = $pa.$v["file"];
					if (file_exists($oldfile)) {
						#echo "unlink: ".$oldfile."<br>";
						unlink($oldfile);
					}
				}
				
				#wp_get_attachment_url
				#echo "unlink main: $pa$mainfilename";
				unlink($pa.$mainfilename);
				wp_delete_attachment( $postid, TRUE);
				
			}
		}
		return TRUE;
	}


	private function twig_ext_formatnumber($data, $decimals, $dec_point, $thousands_sep) {
         if (!is_numeric($data)) {
           return $data;
         }
         $numArr = explode("-", (string) $data);
         if (count($numArr)==2 && is_numeric($numArr[1]) && $numArr[1]>0) {
           $data = number_format($data, $numArr[1]+1, $dec_point, $thousands_sep);
           return $data;
         }
         $numArr = explode("+", (string) $data);
         if (count($numArr)==2 && is_numeric($numArr[1]) && $numArr[1]>0) {
           $data = number_format($data, 0, $dec_point, $thousands_sep);
           return $data;
         }
         $data = number_format($data, $decimals, $dec_point, $thousands_sep);
         return $data;
	}
	
	
	
private function addTwigExtensions() {
		if ($this->isTwig3 || $this->isTwig332) {
			$this->twig_environment->addExtension(new \Twig\Extension\StringLoaderExtension()); #https://twig.symfony.com/doc/3.x/api.html 
		}
		if ($this->isTwig2 || $this->isTwig3 || $this->isTwig332) {
			$twig_extra_filter_sortbyjsonfield = new \Twig\TwigFilter('sortbyjsonfield', function ($data, $sortdata) {
				return $this->twig_ext_sortbyjsonfield($data, $sortdata);
			});
			$twig_extra_filter_dateformat = new \Twig\TwigFilter('dateformat', function ($data, $dateformatstr, $datetimezone, $datelocale) {
				return $this->twig_ext_dateformat($data, $dateformatstr, $datetimezone, $datelocale);
			});
			$twig_extra_filter_converthex2ascii = new \Twig\TwigFilter('converthex2ascii', function ($data) {
				return $this->twig_ext_converthex2ascii($data);
			});
			$twig_extra_filter_convert2html = new \Twig\TwigFilter('convert2html', function ($data) {
				return $this->twig_ext_convert2html($data);
			});
			$twig_extra_filter_dump = new \Twig\TwigFilter('dump', function ($data) {
				return $this->twig_ext_dump($data);
			});
			$twig_extra_filter_md5 = new \Twig\TwigFilter('md5', function ($data) {
				return $this->twig_ext_md5($data);
			});
			$twig_extra_filter_preg_replace = new \Twig\TwigFilter('preg_replace', function ($data, $pattern, $replacement) {
				return $this->twig_ext_preg_replace($data, $pattern, $replacement);
			});
			$twig_extra_filter_sortbyarray = new \Twig\TwigFilter('sortbyarray', function ($data, $sorttype, $sortflag=SORT_REGULAR) {
				return $this->twig_ext_sortbyarray($data, $sorttype, $sortflag);
			});
			$twig_extra_filter_htmlentitydecode = new \Twig\TwigFilter('html_entity_decode', function ($data, $flags="", $encoding="") {
				return $this->twig_ext_html_entity_decode($data, $flags, $encoding);
			});
			$twig_extra_filter_removenonprintable = new \Twig\TwigFilter('removenonprintable', function ($data, $replacement) {
				return $this->twig_ext_removenonprintable($data, $replacement);
			});
			$twig_extra_filter_htmlentities = new \Twig\TwigFilter('htmlentities', function ($data, $flags, $encoding, $double_encode) {
				return $this->twig_ext_htmlentities($data, $flags, $encoding, $double_encode);
			});
			$twig_extra_filter_htmlspecialchars_decode = new \Twig\TwigFilter('htmlspecialchars_decode', function ($data) {
				return $this->twig_ext_htmlspecialchars_decode($data);
			});
			$twig_extra_filter_base64encode = new \Twig\TwigFilter('base64encode', function ($data) {
				return $this->twig_ext_base64encode($data);        
			});
			$twig_extra_filter_removespecialcharsinurl  = new \Twig\TwigFilter('removespecialcharsinurl', function ($data) {
				return $this->twig_ext_removespecialcharsinurl($data);
			});
			$twig_extra_filter_stringshorter  = new \Twig\TwigFilter('stringshorter', function ($data, $length, $suffix) {
				return $this->twig_ext_stringshorter($data, $length, $suffix);
			});
			$twig_extra_filter_numberformat  = new \Twig\TwigFilter('formatnumber', function ($data, $decimals, $dec_point, $thousands_sep) {
				return $this->twig_ext_formatnumber($data, $decimals, $dec_point, $thousands_sep);
			});
			$twig_extra_filter_doshortcode  = new \Twig\TwigFilter('doshortcode', function ($data) {
				return $this->twig_ext_doshortcode($data);
			});
			$twig_extra_filter_jsondecode  = new \Twig\TwigFilter('json_decode', function ($data, $assoc=FALSE, $depth=512, $options=0) {
				return $this->twig_ext_jsondecode($data, $assoc, $depth, $options);
			});
			$twig_extra_filter_jsondecode4twig  = new \Twig\TwigFilter('json_decode_4twig', function ($data, $assoc=FALSE, $depth=512, $options=0) {
				return $this->twig_ext_jsondecode4twig($data, $assoc, $depth, $options);
			});
			$twig_extra_filter_mediastore = new \Twig\TwigFilter('mediastore', function ($data) {
				return $this->twig_ext_mediastore($data);
			});

			$twig_extra_filter_urldecode = new \Twig\TwigFilter('urldecode', function ($data) {
				return $this->twig_ext_urldecode($data);
			});
			$this->twig_environment->addFilter($twig_extra_filter_urldecode); 
			
			$twig_extra_filter_stripslashes = new \Twig\TwigFilter('stripslashes', function ($data) {
				return $this->twig_ext_stripslashes($data);
			});
			$this->twig_environment->addFilter($twig_extra_filter_stripslashes); 

			# twig 2,3 only BEGIN
			$twig_extra_filter_insert_taxonomy = new \Twig\TwigFunction('wp_insert_taxonomy', function ($pageid, $taxonomySlug, $taxonomyValue, $debug=FALSE) {
				return $this->twig_ext_insert_taxonomy($pageid, $taxonomySlug, $taxonomyValue, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_insert_taxonomy);

			$twig_extra_filter_clear_taxonomy = new \Twig\TwigFunction('wp_clear_taxonomy', function ($taxonomySlug, $debug=FALSE) {
				return $this->twig_ext_clear_taxonomy($taxonomySlug, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_clear_taxonomy);

			$twig_extra_filter_get_page_properties = new \Twig\TwigFunction('wp_get_page_properties', function ($debug=FALSE) {
				return $this->twig_ext_get_page_properties($debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_get_page_properties);

			$twig_extra_filter_get_cp_by_cpf_keyvalue = new \Twig\TwigFunction('wp_get_cp_by_cpf_keyvalue', function ($post_type="", $key="", $value="", $debug=FALSE) {
				return $this->twig_ext_get_cp_by_cpf_keyvalue($post_type, $key, $value, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_get_cp_by_cpf_keyvalue);

			$twig_extra_filter_get_custom_field_value = new \Twig\TwigFunction('wp_get_custom_field_value', function ($pageid, $key, $debug=FALSE) {
				return $this->twig_ext_get_custom_field_value($pageid, $key, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_get_custom_field_value);
			
			$twig_extra_filter_insert_custom_field_keyvalue = new \Twig\TwigFunction('wp_insert_custom_field_keyvalue', function ($pageid, $key, $value, $debug=FALSE) {
				return $this->twig_ext_create_insert_custom_field_keyvalue($pageid, $key, $value, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_insert_custom_field_keyvalue);

			$twig_extra_filter_create_new_custom_post = new \Twig\TwigFunction('wp_create_new_custom_post', function ($cptslug, $titel, $name="", $content="", $publishdate="", $postStatusUsed="publish", $authorid="", $debug=FALSE) {
				return $this->twig_ext_create_new_custom_post($cptslug, $titel, $name, $content, $publishdate, $postStatusUsed, $authorid, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_create_new_custom_post);
			
			$twig_extra_filter_delete_custom_post = new \Twig\TwigFunction('wp_delete_custom_post', function (int $postid, bool $force_delete = FALSE, $debug=FALSE) {
				return $this->twig_ext_delete_custom_post($postid, $force_delete, $debug);
			});
			$this->twig_environment->addFunction($twig_extra_filter_delete_custom_post);

			$twig_extra_filter_get_data_of_uploaded_file = new \Twig\TwigFunction('get_data_of_uploaded_file', function ($filename) {
				return $this->twig_ext_get_data_of_uploaded_file($filename);
			});
			$this->twig_environment->addFunction($twig_extra_filter_get_data_of_uploaded_file);

			$twig_extra_filter_get_file = new \Twig\TwigFunction('get_file', function ($filename) {
				return $this->twig_ext_get_file($filename);
			});
			$this->twig_environment->addFunction($twig_extra_filter_get_file);

			$twig_extra_function_base64encode_savefile = new \Twig\TwigFunction('base64encode_savefile', function ($filename) {
				return $this->twig_ext_base64encode_savefile($filename);
			});
			$this->twig_environment->addFunction($twig_extra_function_base64encode_savefile);

			$twig_extra_function_db_select = new \Twig\TwigFunction('jci_db_select', function ($db_fields, $db_table_name, $db_where="", $is_wp_db=1) {   # SELECT $db_fields FROM $db_table_name WHERE $db_where
				return $this->twig_ext_db_select($db_fields, $db_table_name, $db_where, $is_wp_db);
			});
			$this->twig_environment->addFunction($twig_extra_function_db_select);
			
			$twig_extra_function_db_insert = new \Twig\TwigFunction('jci_db_insert', function ($db_table_name, $json_for_db, $is_wp_db=1) {   # INSERT INTO $db_table_name ('key1', 'key2',... ) VALUES ('val1', 'val2',...)
				return $this->twig_ext_db_insert($db_table_name, $json_for_db, $is_wp_db);
			});
			$this->twig_environment->addFunction($twig_extra_function_db_insert);

			$twig_extra_function_db_delete = new \Twig\TwigFunction('jci_db_delete', function ($db_table_name, $db_where="", $is_wp_db=1) {   # DELETE FROM $db_table_name WHERE $db_where
				return $this->twig_ext_db_delete($db_table_name, $db_where, $is_wp_db);
			});
			$this->twig_environment->addFunction($twig_extra_function_db_delete);

			$twig_extra_function_db_update = new \Twig\TwigFunction('jci_db_update', function ($db_table_name, $json_for_db, $db_where="", $is_wp_db=1) {   # DELETE FROM $db_table_name WHERE $db_where
				return $this->twig_ext_db_update($db_table_name, $json_for_db, $db_where, $is_wp_db);
			});
			$this->twig_environment->addFunction($twig_extra_function_db_update);

			$twig_extra_function_db_create = new \Twig\TwigFunction('jci_db_create', function ($db_table_name, $json_for_db) {   # CREATE TABLE table_name (    column2 datatype,    column3 datatype,   ....); 
				return $this->twig_ext_db_create($db_table_name, $json_for_db);
			});
			$this->twig_environment->addFunction($twig_extra_function_db_create);

			$twig_extra_function_user_create = new \Twig\TwigFunction('jci_user_create', function ($username, $password, $email="", $role="") { 
				return $this->twig_extra_function_user_create($username, $password, $email, $role);
			});
			$this->twig_environment->addFunction($twig_extra_function_user_create);

			$twig_extra_function_woocommmerce_calc_authorization = new \Twig\TwigFunction('jci_woo_calc_auth', function ($consumer_key, $consumer_secret, $request_uri, $http_method) { 
				return $this->twig_extra_function_woocommmerce_calc_authorization($consumer_key, $consumer_secret, $request_uri, $http_method);
			});
			$this->twig_environment->addFunction($twig_extra_function_woocommmerce_calc_authorization);

			$twig_extra_function_jci_setcookie = new \Twig\TwigFunction('jci_setcookie', function ($name, $value="", $expires=0, $path="", $domain="", $secure=false, $httponly=false) { 
				return $this->twig_extra_function_jci_setcookie($name, $value, $expires, $path, $domain, $secure, $httponly);
			});
			$this->twig_environment->addFunction($twig_extra_function_jci_setcookie);
			$twig_extra_function_jci_getcookie = new \Twig\TwigFunction('jci_getcookie', function ($name="") { 
				return $this->twig_extra_function_jci_getcookie($name);
			});
			$this->twig_environment->addFunction($twig_extra_function_jci_getcookie);
			$twig_extra_function_jci_forward = new \Twig\TwigFunction('jci_forward', function ($url) { 
				return $this->twig_extra_function_jci_forward($url);
			});
			$this->twig_environment->addFunction($twig_extra_function_jci_forward);
			# twig 2,3 only END
		} else {
			$twig_extra_filter_sortbyjsonfield = new Twig_SimpleFilter('sortbyjsonfield', function ($data, $sortdata) {
				return $this->twig_ext_sortbyjsonfield($data, $sortdata);
			});
			$twig_extra_filter_dateformat = new Twig_SimpleFilter('dateformat', function ($data, $dateformatstr, $datetimezone, $datelocale) {
				return $this->twig_ext_dateformat($data, $dateformatstr, $datetimezone, $datelocale);
			});
			$twig_extra_filter_converthex2ascii = new Twig_SimpleFilter('converthex2ascii', function ($data) {
				return $this->twig_ext_converthex2ascii($data);
			});
			$twig_extra_filter_convert2html = new Twig_SimpleFilter('convert2html', function ($data) {
				return $this->twig_ext_convert2html($data);
			});
			$twig_extra_filter_dump = new Twig_SimpleFilter('dump', function ($data) {
				return $this->twig_ext_dump($data);
			});
			$twig_extra_filter_md5 = new Twig_SimpleFilter('md5', function ($data) {
				return $this->twig_ext_md5($data);
			});
			$twig_extra_filter_preg_replace = new Twig_SimpleFilter('preg_replace', function ($data, $pattern, $replacement) {
				return $this->twig_ext_preg_replace($data, $pattern, $replacement);
			});
			$twig_extra_filter_sortbyarray = new Twig_SimpleFilter('sortbyarray', function ($data, $sorttype, $sortflag=SORT_REGULAR) {
				return $this->twig_ext_sortbyarray($data, $sorttype, $sortflag);
			});
			$twig_extra_filter_htmlentitydecode = new Twig_SimpleFilter('html_entity_decode', function ($data, $flags="", $encoding="") {
				return $this->twig_ext_html_entity_decode($data, $flags, $encoding);
			});
			$twig_extra_filter_removenonprintable = new Twig_SimpleFilter('removenonprintable', function ($data, $replacement) {
				return $this->twig_ext_removenonprintable($data, $replacement);
			});
			$twig_extra_filter_htmlentities = new Twig_SimpleFilter('htmlentities', function ($data, $flags, $encoding, $double_encode) {
				return $this->twig_ext_htmlentities($data, $flags, $encoding, $double_encode);
			});
			$twig_extra_filter_htmlspecialchars_decode = new Twig_SimpleFilter('htmlspecialchars_decode', function ($data) {
				return $this->twig_ext_htmlspecialchars_decode($data);
			});
			$twig_extra_filter_base64encode = new Twig_SimpleFilter('base64encode', function ($data) {
				return $this->twig_ext_base64encode($data);        
			});
			$twig_extra_filter_removespecialcharsinurl  = new Twig_SimpleFilter('removespecialcharsinurl', function ($data) {
				return $this->twig_ext_removespecialcharsinurl($data);
			});
			$twig_extra_filter_stringshorter  = new Twig_SimpleFilter('stringshorter', function ($data, $length, $suffix) {
				return $this->twig_ext_stringshorter($data, $length, $suffix);
			});
			$twig_extra_filter_numberformat  = new Twig_SimpleFilter('formatnumber', function ($data, $decimals, $dec_point, $thousands_sep) {
				return $this->twig_ext_formatnumber($data, $decimals, $dec_point, $thousands_sep);
			});
			$twig_extra_filter_doshortcode  = new Twig_SimpleFilter('doshortcode', function ($data) {
				return $this->twig_ext_doshortcode($data);
			});
			$twig_extra_filter_jsondecode  = new Twig_SimpleFilter('json_decode', function ($data, $assoc=FALSE, $depth=512, $options=0) {
				return $this->twig_ext_jsondecode($data, $assoc, $depth, $options);
			});
			$twig_extra_filter_jsondecode4twig = new Twig_SimpleFilter('json_decode_4twig', function ($data, $assoc=FALSE, $depth=512, $options=0) {
				return $this->twig_ext_jsondecode4twig($data, $assoc, $depth, $options);
			});
			$twig_extra_filter_mediastore = new Twig_SimpleFilter('mediastore', function ($data) {
				return $this->twig_ext_mediastore($data);
			});
		}

      $this->twig_environment->addFilter($twig_extra_filter_sortbyjsonfield);
      $this->twig_environment->addFilter($twig_extra_filter_dateformat);
      $this->twig_environment->addFilter($twig_extra_filter_convert2html);
      $this->twig_environment->addFilter($twig_extra_filter_htmlspecialchars_decode);
      $this->twig_environment->addFilter($twig_extra_filter_base64encode);
      $this->twig_environment->addFilter($twig_extra_filter_removespecialcharsinurl);
      $this->twig_environment->addFilter($twig_extra_filter_stringshorter);
      $this->twig_environment->addFilter($twig_extra_filter_numberformat);
      $this->twig_environment->addFilter($twig_extra_filter_converthex2ascii);
      $this->twig_environment->addFilter($twig_extra_filter_dump);
      $this->twig_environment->addFilter($twig_extra_filter_md5);
      $this->twig_environment->addFilter($twig_extra_filter_preg_replace);
      $this->twig_environment->addFilter($twig_extra_filter_sortbyarray);
      $this->twig_environment->addFilter($twig_extra_filter_htmlentitydecode);
      $this->twig_environment->addFilter($twig_extra_filter_htmlentities);
      $this->twig_environment->addFilter($twig_extra_filter_removenonprintable);
      $this->twig_environment->addFilter($twig_extra_filter_doshortcode);
		$this->twig_environment->addFilter($twig_extra_filter_jsondecode);
      $this->twig_environment->addFilter($twig_extra_filter_jsondecode4twig);
      $this->twig_environment->addFilter($twig_extra_filter_mediastore);
	}
	
    private function sortJsonArray($arrayIn, $sortField, $sortOrder, $sortFlag) {
      @usort($arrayIn, function ($a, $b) use ($sortField, $sortOrder, $sortFlag) {
        $eval = NULL;
        for ($i=1;$i<=count($sortField);$i++) {
          if ($sortField[$i]=="") {
            continue;
          }
          $valA = $a[$sortField[$i]];
          $valB = $b[$sortField[$i]];
			if (preg_match("/^date/", trim($sortFlag[$i]))) {
				# sortbyjsonfield("datumString,desc,date#us#-") where - is the separator used in JSON, needed for us is /
				# sortbyjsonfield("datumString,desc,date#eu#/") where / is the separator used in JSON, needed for eu is -
				# see note at https://www.php.net/manual/en/function.strtotime.php
				# d-m-Y vs m/d/Y
				$sortdateArr = explode("#", $sortFlag[$i], 3);
				$dateformatinjson = $sortdateArr[1];
				$newdateseparatorinjson = "/"; # default us
				if ("eu"==$dateformatinjson) {
					$newdateseparatorinjson = "-"; 
				}
				$dateseparatorinjson = $sortdateArr[2];
				if (""!=$dateformatinjson && ""!=$dateseparatorinjson) {
					$dateArrAWithTime = explode(" ", $valA, 2);
					$dateArrA = explode($dateseparatorinjson, $dateArrAWithTime[0]);
					$valA = join($newdateseparatorinjson, $dateArrA);
					if (""!=$dateArrAWithTime[1]) {
						$valA .= " ".$dateArrAWithTime[1];
					}
					$dateArrBWithTime = explode(" ", $valB, 2);
					$dateArrB = explode($dateseparatorinjson, $dateArrBWithTime[0]);
					$valB = join($newdateseparatorinjson, $dateArrB);
					if (""!=$dateArrBWithTime[1]) {
						$valB .= " ".$dateArrBWithTime[1];
					}
				}
				
				$valAtmp = strtotime($valA);
				if ($valAtmp) {
					$valA = $valAtmp;
				}
				$valBtmp = strtotime($valB);
				if ($valBtmp) {
					$valB = $valBtmp;
				}
			}

          $sr = $sortField[$i];
          if (preg_match("/\./", $sr)) {
            $tmpA = $a;
            $tmpB = $b;
            $srArr = explode(".", $sr);
            for ($ji=0;$ji<count($srArr);$ji++) {
              $tmpA = $tmpA[$srArr[$ji]];
              $tmpB = $tmpB[$srArr[$ji]];
            }
            $valA = $tmpA;
            $valB = $tmpB;
          }

          $this->jci_collectDebugMessage("sorting $sr, order: ".$sortOrder[$i].": ".$valA." vs. ".$valB);
          if ($sortFlag[$i]=="num" && is_numeric($valA) && is_numeric($valB)) {
            if ($sortOrder[$i]=="desc") {
              $eval .= $valB-$valA;
            } else {
              $eval .= $valA-$valB;
            }
          } else if ($sortFlag[$i]=="date" && is_numeric($valA) && is_numeric($valB)) {
            if ($sortOrder[$i]=="desc") {
              $eval .= $valB-$valA;
            } else {
              $eval .= $valA-$valB;
            }
          } else {
             $d = strtolower($valB);
             $t = strtolower($valA);
          if ($sortOrder[$i]=="desc") {
              $eval .= strcmp($d,$t);
            } else {
              $eval .= strcmp($t,$d);
            }
          }
        }
        return $eval;
      });
      return $arrayIn;
    }	
}



?>
